#include <stdio.h>

#define MAXN 1001

int Time[MAXN], Fine[MAXN], N;

void Sort(int order[]) 
{
    int i, n;

    for ( i = 0; i < N; i++ ) order[i] = i;

    for ( n = 1; n < N; n++ ) {
        int time = 0;
        int fine = 0;
        for ( i = 0; i < n; i++ ) {
            fine += Fine[order[i]] * time;
            time += Time[order[i]];
        }
        fine += Fine[order[n]] * time;

        // try all positions        
        int best = fine;
        int bestpos = n;
        int cur = order[n];
        for ( i = n - 1; i >= 0; i-- ) {
            fine += Fine[order[i]] * Time[cur];
            fine -= Fine[cur] * Time[order[i]];
            if ( fine < best ) {
                best = fine;
                bestpos = i;
            }
        }

        // insert
        for ( i = n - 1; i >= bestpos; i-- )
            order[i + 1] = order[i];
        order[bestpos] = cur;
    }
}

int main()
{
    int i;
    int order[MAXN];
    int nc = 1;

    while ( true ) {
        scanf(" %d", &N);
        if ( N == 0 ) break;

        for ( i = 0; i < N; i++ ) scanf(" %d %d", &Time[i], &Fine[i]);

        printf("Case #%d: ", nc++);
        Sort(order);
        for ( i = 0; i < N; i++ ) printf("%d ", order[i] + 1);
        printf("\n");
    }

    return 0;
}
